<template>
  <div class="app-container">
    <!--工具栏-->
    <div class="head-container">
      <div>
        <el-select v-model="searchParam._mineIndex" placeholder="所属矿山" clearable size="small" class="filter-item" style="width: 200px;">
          <el-option v-for="mine in mineList" :key="mine.index" :label="mine.name" :value="mine.index" />
        </el-select>
        <el-input v-model="searchParam.specialWorkTypeLike" clearable size="small" placeholder="特种作业类型" style="width: 200px;" class="filter-item" />
        <el-button class="filter-item" size="mini" type="success" icon="el-icon-search" @click="searchSubmit">搜索</el-button>
        <el-button class="filter-item" size="mini" type="warning" icon="el-icon-refresh-left" @click="searchParamReset">重置</el-button>
        <el-tooltip class="item" effect="dark" content="按当前查询条件导出" placement="top">
          <el-button :loading="exporting" class="filter-item" size="mini" type="info" plain icon="el-icon-download" @click="exportSubmit">导出</el-button>
        </el-tooltip>
      </div>
      <!-- <el-button class="filter-item" size="mini" type="primary" icon="el-icon-plus" @click="doAdd()">新增</el-button> -->
    </div>
    <!--弹出框1-->
    <el-dialog append-to-body :close-on-click-modal="true" :visible.sync="dialog1Show" :title="editState==1?'新增':editState==2?'修改':'查看'" width="960px">
      <el-form ref="dialog1Form" :model="dialog1Data" :hide-required-asterisk="!dialog1Editing" :rules="dialog1Rules" size="mini" label-width="180px" style="margin-right: 80px;">
        <el-divider content-position="left">基本信息</el-divider>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="姓名：" prop="id">
              <span v-show="editState!=1">{{ dialog1Data.name }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="性别：" prop="sex">
              <span>{{ dialog1Data.sex==1?'男':dialog1Data.sex==2?'女':'' }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="所属部门：" prop="departmentId">
              <span>{{ dialog1Data.departmentName }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="岗位：" prop="jobId">
              <span v-show="!dialog1Editing">{{ dialog1Data.jobName }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="身份证号：" prop="idcard">
              <span v-show="!dialog1Editing">{{ dialog1Data.idcard }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="工种：" prop="workType">
              <span v-show="!dialog1Editing">{{ dialog1Data.workType }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="民族：" prop="national">
              <span v-show="!dialog1Editing">{{ dialog1Data.national }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="职务：" prop="position">
              <span v-show="!dialog1Editing">{{ dialog1Data.position }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="政治面貌：" prop="politicalAffiliation">
              <span>{{ dialog1Data.politicalAffiliation }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="联系电话：" prop="phone">
              <span v-show="!dialog1Editing">{{ dialog1Data.phone }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="学历：" prop="schoolingRecord">
              <span v-show="!dialog1Editing">{{ dialog1Data.schoolingRecord }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="职称：" prop="professionalTitle">
              <span v-show="!dialog1Editing">{{ dialog1Data.professionalTitle }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="专业：" prop="specialty">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialty }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="出生日期：" prop="birthday">
              <span v-show="!dialog1Editing">{{ dialog1Data.birthday }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="入职时间：" prop="inductionDate">
              <span v-show="!dialog1Editing">{{ dialog1Data.inductionDate }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="常住地址：" prop="address">
              <span v-show="!dialog1Editing">{{ dialog1Data.address }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="照片：" prop="photoPath">
              <div v-for="file in dialog1Data._photoList" v-show="!dialog1Editing" :key="file.url">
                <el-link type="primary" @click="openFile(file)">{{ file.name }}</el-link>
              </div>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="紧急联系人：" prop="emergencyContact">
              <span v-show="!dialog1Editing">{{ dialog1Data.emergencyContact }}</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="紧急联系人电话：" prop="emergencyPhone">
              <span v-show="!dialog1Editing">{{ dialog1Data.emergencyPhone }}</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-divider content-position="left">特殊作业资格信息</el-divider>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="证件类型：" prop="specialCertificateType">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialCertificateType }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.specialCertificateType" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="证件号：" prop="specialCertificateCode">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialCertificateCode }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.specialCertificateCode" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="作业类别：" prop="specialWorkType">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialWorkType }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.specialWorkType" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="初领日期：" prop="specialFirstTimeDate">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialFirstTimeDate }}</span>
              <el-date-picker v-show="dialog1Editing" v-model="dialog1Data.specialFirstTimeDate" value-format="yyyy-MM-dd" type="date" placeholder="选择日期" style="width: 100%;" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="操作项目：" prop="specialOperationOption">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialOperationOption }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.specialOperationOption" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="复审截止日期：" prop="specialCertificateReviewDate">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialCertificateReviewDate }}</span>
              <el-date-picker v-show="dialog1Editing" v-model="dialog1Data.specialCertificateReviewDate" value-format="yyyy-MM-dd" type="date" placeholder="选择日期" style="width: 100%;" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="签发机关：" prop="specialIssuingAuthority">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialIssuingAuthority }}</span>
              <el-input v-show="dialog1Editing" v-model="dialog1Data.specialIssuingAuthority" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="有效期（起）：" prop="specialBeginDate">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialBeginDate }}</span>
              <template v-show="dialog1Editing">
                <el-date-picker v-show="dialog1Editing" v-model="dialog1Data.specialBeginDate" value-format="yyyy-MM-dd" type="date" placeholder="选择日期" style="width: 100%;" />
              </template>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="有效期（止）：" prop="specialEndDate">
              <span v-show="!dialog1Editing">{{ dialog1Data.specialEndDate }}</span>
              <template v-show="dialog1Editing">
                <el-date-picker v-show="dialog1Editing" v-model="dialog1Data.specialEndDate" value-format="yyyy-MM-dd" type="date" placeholder="选择日期" style="width: 100%;" />
              </template>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="特种作业证书：" prop="specialCertificateFilePath">
              <div v-for="file in dialog1Data._specialCertificateFileList" v-show="!dialog1Editing" :key="file.url">
                <el-link type="primary" @click="openFile(file)">{{ file.name }}</el-link>
              </div>
              <el-upload
                v-show="dialog1Editing"
                class="upload-demo"
                action="/api/file/upload"
                multiple
                :headers="httpHeaders"
                :limit="1"
                :on-success="upFileSuccess"
                :on-remove="upFileRemove"
                :on-error="upFileError"
                :on-exceed="upFileExceed"
                :before-upload="upFileBefore"
                :on-preview="openFile"
                :file-list="dialog1Data._specialCertificateFileListShow"
              >
                <el-button size="small" type="primary">点击上传</el-button>
                <div slot="tip" class="el-upload__tip">图片不要超过20M，仅支持jpeg、png格式</div>
              </el-upload>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div v-show="dialog1Editing" slot="footer" class="dialog-footer">
        <el-button type="text" @click="dialog1Show=false">取消</el-button>
        <el-button :loading="dialog1Saving" type="primary" @click="dialog1Submit">确认</el-button>
      </div>
    </el-dialog>
    <!--弹出框2-->
    <el-dialog append-to-body :close-on-click-modal="true" :visible.sync="dialog2Show" :title="'确认删除'" width="580px">
      <div>
        <span>确认要删除人员信息：</span><span style="font-weight: bold;">{{ dialog2Data.name }}</span><span>吗？</span>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button type="text" @click="dialog2Show=false">取消</el-button>
        <el-button :loading="dialog2Saving" type="primary" @click="dialog2Submit">确认</el-button>
      </div>
    </el-dialog>
    <!--表格-->
    <el-table ref="table" v-loading="searching" :data="tableData" row-key="id">
      <el-table-column :show-overflow-tooltip="true" prop="id" label="编号" width="100px" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="mineName" label="所属矿山" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="name" label="姓名" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="sex" label="性别" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="phone" label="联系方式" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="specialWorkType" label="特种作业类型" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="specialEndDate" label="证件有效期" align="center" />
      <el-table-column :show-overflow-tooltip="true" prop="specialCertificateFilePath" label="特种证" align="center">
        <template slot-scope="scope">
          <div :style="{'width':'100px','height':'100px','background-color':dateToNow(scope.row.specialEndDate)<7?'#F56C6C':dateToNow(scope.row.specialEndDate)<30?'#E6A23C':null,'margin':'auto'}">
            <el-image
              :style="{'width':'100px','height':'100px','opacity':dateToNow(scope.row.specialEndDate)<30?0.7:1}"
              :src="getFirstFileUrl(scope.row.specialCertificateFilePath)"
              :preview-src-list="[getFirstFileUrl(scope.row.specialCertificateFilePath)]"
              fit="cover"
            />
          </div>
        </template>
      </el-table-column>
      <el-table-column :show-overflow-tooltip="true" prop="inductionDate" label="入职时间" align="center" />
      <el-table-column label="操作" width="300px" align="center" fixed="right">
        <template slot-scope="scope">
          <el-button size="mini" round @click="doEdit(scope.row.id,false)">查看</el-button>
          <!-- <el-button size="mini" round @click="doEdit(scope.row.id,true)">修改</el-button> -->
          <!-- <el-button size="mini" round @click="doDelete(scope.row.id)">删除</el-button> -->
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :page-sizes="[10, 20, 50, 100]"
      :current-page.sync="searchParam.page"
      :page-size.sync="searchParam.count"
      :total="searchResult.total"
      layout="total, sizes, prev, pager, next, jumper"
      @size-change="searchSubmit"
      @current-change="searchSubmit"
    />
  </div>
</template>

<script>
import staffApi from '@/api/kd/staff'
import { getToken } from '@/utils/auth'
import { mapGetters } from 'vuex'
import mineApi from '@/api/kd/mine'
import { downloadFile } from '@/utils'

const searchParam = {// 默认搜索条件
  page: 1,
  count: 10,
  searchCount: true
}
export default {
  name: 'CStaffSpecial', // 本页面名
  components: { },
  data() {
    return {
      mineList: [],
      httpHeaders: {
        'Authorization': getToken()
      },
      searching: false,
      exporting: false,
      searchParam: {},
      searchResult: {
        total: 0,
        results: [] // 搜索结果
      },
      dialog1Show: false,
      dialog1Editing: false,
      dialog1Saving: false,
      dialog1Data: {},
      dialog1Rules: {},
      editState: 0, // （刚打开窗口时）记录了上次窗口作用；（保存编辑时）记录了当前窗口作用； 0无 1新增 2修改 3查看
      addingData: {}, // 上次正在新增时的内容，下次打开dialog1窗口时记录下来
      dialog2Show: false,
      dialog2Saving: false,
      dialog2Data: {}
    }
  },
  computed: {
    ...mapGetters([
      'user',
      'baseApi'
    ]),
    tableData() {
      // 此处对返回值进行算法重组
      return this.searchResult.results
    }
  },
  mounted() {
    // 矿山选项卡
    mineApi.getEnableMine().then(response => {
      let i = 1
      let mineList = response.results
      mineList = mineList.filter(x => x.mineType === 1) // 只保留地下矿山
      mineList.forEach(x => { x.index = i++ })
      this.mineList = mineList
    })
    this.searchParamReset()
    this.searchSubmit()
  },
  methods: {
    searchParamReset() {
      this.searchParam = JSON.parse(JSON.stringify(searchParam))
    },
    searchSubmit() {
      this.searching = true
      if (this.searchParam._mineIndex) {
        const mine = this.mineList[this.searchParam._mineIndex - 1]
        this.searchParam.mineType = mine.mineType
        this.searchParam.mineId = mine.id
      } else {
        this.searchParam.mineType = null
        this.searchParam.mineId = null
      }
      this.searchParam.special = true
      staffApi.getPage(this.searchParam).then(response => {
        this.searching = false
        this.searchResult = response
      }).catch(() => {
        this.searching = false
      })
    },
    exportSubmit() {
      this.exporting = true
      if (this.searchParam._mineIndex) {
        const mine = this.mineList[this.searchParam._mineIndex - 1]
        this.searchParam.mineType = mine.mineType
        this.searchParam.mineId = mine.id
      } else {
        this.searchParam.mineType = null
        this.searchParam.mineId = null
      }
      this.searchParam.special = true
      staffApi.exportSpecialInfo(this.searchParam).then(response => {
        downloadFile(response, '特种作业人员', 'xlsx')
        this.exporting = false
      }).catch(() => {
        this.exporting = false
      })
    },
    dialog1Submit() {
      this.$refs['dialog1Form'].validate(valid => {
        if (!valid) {
          return
        } else {
          this.dialog1Saving = true
          if (this.dialog1Data._specialCertificateFileList) {
            this.dialog1Data.specialCertificateFilePath = JSON.stringify(this.dialog1Data._specialCertificateFileList)
          }
          if (this.editState === 1) { // 新增
            if (this.dialog1Data.special) {
              this.$message.error('此人已经填报了特殊作业工种')
              return
            }
            this.dialog1Data.special = true
            staffApi.set(this.dialog1Data).then(() => { // 新增 -本质-> 修改
              this.dialog1Show = false
              this.$message.success('保存成功')
              setTimeout(() => { // 立即清除会导致输入框Validate一闪变红
                this.dialog1Data = {}
                this.dialog1Saving = false
              }, 500)
              this.searchSubmit()
            }).catch(() => {
              this.dialog1Saving = false
            })
          } else if (this.editState === 2) { // 修改
            if (!this.dialog1Data.special) {
              this.$message.error('此人还未填报过特殊作业工种')
              return
            }
            staffApi.set(this.dialog1Data).then(() => {
              this.dialog1Show = false
              this.$message.success('修改成功')
              setTimeout(() => { // 立即清除会导致输入框Validate一闪变红
                this.dialog1Data = {}
                this.dialog1Saving = false
              }, 500)
              this.searchSubmit()
            }).catch(() => {
              this.dialog1Saving = false
            })
          } else {
            this.$message.error('出错啦，请重试')
            this.dialog1Saving = false
          }
        }
      })
    },
    beforeDialog1Open() { // 窗口打开前的统一操作
      if (this.editState === 1) {
        this.addingData = this.dialog1Data
      }
    },
    doAdd() {
      this.beforeDialog1Open()
      this.editState = 1
      this.dialog1Editing = true
      this.dialog1Data = this.addingData // 初始值：上次编辑的内容
      this.dialog1Show = true
      this.$nextTick(() => {
        this.$refs['dialog1Form'].clearValidate()
      })
    },
    doEdit(id, isEdit) {
      this.beforeDialog1Open()
      this.editState = isEdit ? 2 : 3
      staffApi.getById(id).then(response => {
        console.log(response)
        this.dialog1Data = response
        this.dialog1Data._departmentName = response.departmentName
        if (response.departmentId) {
          this.dialog1Data._departmentSelections = [{ id: response.departmentId, name: response.departmentName }]
        }
        this.dialog1Data._jobName = response.jobName
        if (response.jobId) {
          this.dialog1Data._jobSelections = [{ id: response.jobId, name: response.jobName }]
        }
        if (this.dialog1Data.photoPath) {
          this.dialog1Data._photoList = JSON.parse(this.dialog1Data.photoPath)
          this.dialog1Data._photoListShow = JSON.parse(this.dialog1Data.photoPath) // 数据存放与原始绑定分开，可以防止中途赋值产生的闪烁问题
        }
        if (this.dialog1Data.specialCertificateFilePath) {
          this.dialog1Data._specialCertificateFileList = JSON.parse(this.dialog1Data.specialCertificateFilePath)
          this.dialog1Data._specialCertificateFileListShow = JSON.parse(this.dialog1Data.specialCertificateFilePath) // 数据存放与原始绑定分开，可以防止中途赋值产生的闪烁问题
        }
        this.dialog1Editing = isEdit
        this.dialog1Show = true
      }).catch(() => {
        this.searchSubmit()
      })
    },
    dialog2Submit() {
      this.dialog2Saving = true
      // 删除 -> 修改
      staffApi.set({
        id: this.dialog2Data.id,
        special: false
      }).then(() => {
        this.dialog2Show = false
        this.$message.success('删除成功')
        this.dialog2Data = {}
        this.dialog2Saving = false
        this.searchSubmit()
      }).catch(() => {
        this.dialog2Saving = false
      })
    },
    doDelete(id) {
      staffApi.getById(id).then(response => {
        this.dialog2Data = response
        this.dialog2Show = true
      }).catch(() => {
        this.searchSubmit()
      })
    },
    dialog1Search(queryString) {
      staffApi.getPage({
        nameLike: queryString,
        mineType: this.selectedMine.mineType,
        mineId: this.selectedMine.id
      }).then(response => {
        this.$delete(this.dialog1Data, '_selections') // 解决$set不更新DOM
        this.$set(this.dialog1Data, '_selections', response.results)
      }).catch(() => {
        this.$message.error('出错啦，请重试')
      })
    },
    elementuiUpListFormat(fileList) {
      const filePathArray = []
      fileList.forEach(f => {
        if (f.response && f.response.result) {
          filePathArray.push({
            name: f.name,
            url: f.response.result
          })
        } else if (f.name && f.url) {
          filePathArray.push({
            name: f.name,
            url: f.url
          })
        }
      })
      return filePathArray
    },
    upFileSuccessReport(response, file, fileList) {
      if (!this.dialog1Data._reportFileList) {
        this.dialog1Data._reportFileList = []
      }
      this.dialog1Data._reportFileList.push({
        name: file.name,
        url: response.result
      })
    },
    upFileRemoveReport(file, fileList) {
      this.dialog1Data._reportFileList = this.elementuiUpListFormat(fileList)
    },
    upFileSuccess(response, file, fileList) {
      if (!this.dialog1Data._specialCertificateFileList) {
        this.dialog1Data._specialCertificateFileList = []
      }
      this.dialog1Data._specialCertificateFileList.push({
        name: file.name,
        url: response.result
      })
    },
    upFileRemove(file, fileList) {
      this.dialog1Data._specialCertificateFileList = this.elementuiUpListFormat(fileList)
    },
    upFileSuccessPhoto(response, file, fileList) {
      if (!this.dialog1Data._specialCertificateFileFileList) {
        this.dialog1Data._specialCertificateFileFileList = []
      }
      this.dialog1Data._specialCertificateFileFileList.push({
        name: file.name,
        url: response.result
      })
    },
    upFileRemovePhoto(file, fileList) {
      this.dialog1Data._specialCertificateFileFileList = this.elementuiUpListFormat(fileList)
    },
    upFileError() {
      this.$message.error('上传失败，请稍后再试')
    },
    upFileExceed() {
      this.$message.error('只可以上传一张照片')
    },
    upFileBefore(file) {
      const isIMG = file.type === 'image/jpeg' || file.type === 'image/png'
      const isLtSize = file.size / 1024 / 1024 < 20
      if (!isIMG) {
        this.$message.error('上传图片只能是 JPG/JPEG/PNG 格式')
        return false
      }
      if (!isLtSize) {
        this.$message.error('上传图片大小不能超过 20MB')
        return false
      }
      return true
    },
    openFile(file) {
      if (file.url) {
        window.open(this.baseApi + '/file' + file.url)
      } else if (file.response && file.response.result) {
        window.open(this.baseApi + '/file' + file.response.result)
      }
    },
    getFirstFileUrl(filesJson) {
      if (filesJson) {
        const files = JSON.parse(filesJson)
        if (files && files.length > 0 && files[0].url) {
          return this.baseApi + '/file' + files[0].url
        }
      }
      return ''
    },
    dateToNow(dateString) {
      return (new Date(dateString).getTime() - new Date().getTime()) / (1000 * 60 * 60 * 24)
    },
    stringMosaic(str, showLastNumber) {
      if (str) {
        return '**' + str.substring(str.length - showLastNumber)
      }
      return ''
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  ::v-deep .el-input-number .el-input__inner {
    text-align: left;
  }
  ::v-deep .vue-treeselect__control,::v-deep .vue-treeselect__placeholder,::v-deep .vue-treeselect__single-value {
    height: 30px;
    line-height: 30px;
  }
</style>
